faddr2line 6.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222
  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-2.0
  3. #
  4. # Translate stack dump function offsets.
  5. #
  6. # addr2line doesn't work with KASLR addresses. This works similarly to
  7. # addr2line, but instead takes the 'func+0x123' format as input:
  8. #
  9. # $ ./scripts/faddr2line ~/k/vmlinux meminfo_proc_show+0x5/0x568
  10. # meminfo_proc_show+0x5/0x568:
  11. # meminfo_proc_show at fs/proc/meminfo.c:27
  12. #
  13. # If the address is part of an inlined function, the full inline call chain is
  14. # printed:
  15. #
  16. # $ ./scripts/faddr2line ~/k/vmlinux native_write_msr+0x6/0x27
  17. # native_write_msr+0x6/0x27:
  18. # arch_static_branch at arch/x86/include/asm/msr.h:121
  19. # (inlined by) static_key_false at include/linux/jump_label.h:125
  20. # (inlined by) native_write_msr at arch/x86/include/asm/msr.h:125
  21. #
  22. # The function size after the '/' in the input is optional, but recommended.
  23. # It's used to help disambiguate any duplicate symbol names, which can occur
  24. # rarely. If the size is omitted for a duplicate symbol then it's possible for
  25. # multiple code sites to be printed:
  26. #
  27. # $ ./scripts/faddr2line ~/k/vmlinux raw_ioctl+0x5
  28. # raw_ioctl+0x5/0x20:
  29. # raw_ioctl at drivers/char/raw.c:122
  30. #
  31. # raw_ioctl+0x5/0xb1:
  32. # raw_ioctl at net/ipv4/raw.c:876
  33. #
  34. # Multiple addresses can be specified on a single command line:
  35. #
  36. # $ ./scripts/faddr2line ~/k/vmlinux type_show+0x10/45 free_reserved_area+0x90
  37. # type_show+0x10/0x2d:
  38. # type_show at drivers/video/backlight/backlight.c:213
  39. #
  40. # free_reserved_area+0x90/0x123:
  41. # free_reserved_area at mm/page_alloc.c:6429 (discriminator 2)
  42. set -o errexit
  43. set -o nounset
  44. READELF="${CROSS_COMPILE:-}readelf"
  45. ADDR2LINE="${CROSS_COMPILE:-}addr2line"
  46. SIZE="${CROSS_COMPILE:-}size"
  47. NM="${CROSS_COMPILE:-}nm"
  48. command -v awk >/dev/null 2>&1 || die "awk isn't installed"
  49. command -v ${READELF} >/dev/null 2>&1 || die "readelf isn't installed"
  50. command -v ${ADDR2LINE} >/dev/null 2>&1 || die "addr2line isn't installed"
  51. command -v ${SIZE} >/dev/null 2>&1 || die "size isn't installed"
  52. command -v ${NM} >/dev/null 2>&1 || die "nm isn't installed"
  53. usage() {
  54. echo "usage: faddr2line [--list] <object file> <func+offset> <func+offset>..." >&2
  55. exit 1
  56. }
  57. warn() {
  58. echo "$1" >&2
  59. }
  60. die() {
  61. echo "ERROR: $1" >&2
  62. exit 1
  63. }
  64. # Try to figure out the source directory prefix so we can remove it from the
  65. # addr2line output. HACK ALERT: This assumes that start_kernel() is in
  66. # init/main.c! This only works for vmlinux. Otherwise it falls back to
  67. # printing the absolute path.
  68. find_dir_prefix() {
  69. local objfile=$1
  70. local start_kernel_addr=$(${READELF} -sW $objfile | awk '$8 == "start_kernel" {printf "0x%s", $2}')
  71. [[ -z $start_kernel_addr ]] && return
  72. local file_line=$(${ADDR2LINE} -e $objfile $start_kernel_addr)
  73. [[ -z $file_line ]] && return
  74. local prefix=${file_line%init/main.c:*}
  75. if [[ -z $prefix ]] || [[ $prefix = $file_line ]]; then
  76. return
  77. fi
  78. DIR_PREFIX=$prefix
  79. return 0
  80. }
  81. __faddr2line() {
  82. local objfile=$1
  83. local func_addr=$2
  84. local dir_prefix=$3
  85. local print_warnings=$4
  86. local func=${func_addr%+*}
  87. local offset=${func_addr#*+}
  88. offset=${offset%/*}
  89. local size=
  90. [[ $func_addr =~ "/" ]] && size=${func_addr#*/}
  91. if [[ -z $func ]] || [[ -z $offset ]] || [[ $func = $func_addr ]]; then
  92. warn "bad func+offset $func_addr"
  93. DONE=1
  94. return
  95. fi
  96. # Go through each of the object's symbols which match the func name.
  97. # In rare cases there might be duplicates.
  98. file_end=$(${SIZE} -Ax $objfile | awk '$1 == ".text" {print $2}')
  99. while read symbol; do
  100. local fields=($symbol)
  101. local sym_base=0x${fields[0]}
  102. local sym_type=${fields[1]}
  103. local sym_end=${fields[3]}
  104. # calculate the size
  105. local sym_size=$(($sym_end - $sym_base))
  106. if [[ -z $sym_size ]] || [[ $sym_size -le 0 ]]; then
  107. warn "bad symbol size: base: $sym_base end: $sym_end"
  108. DONE=1
  109. return
  110. fi
  111. sym_size=0x$(printf %x $sym_size)
  112. # calculate the address
  113. local addr=$(($sym_base + $offset))
  114. if [[ -z $addr ]] || [[ $addr = 0 ]]; then
  115. warn "bad address: $sym_base + $offset"
  116. DONE=1
  117. return
  118. fi
  119. addr=0x$(printf %x $addr)
  120. # weed out non-function symbols
  121. if [[ $sym_type != t ]] && [[ $sym_type != T ]]; then
  122. [[ $print_warnings = 1 ]] &&
  123. echo "skipping $func address at $addr due to non-function symbol of type '$sym_type'"
  124. continue
  125. fi
  126. # if the user provided a size, make sure it matches the symbol's size
  127. if [[ -n $size ]] && [[ $size -ne $sym_size ]]; then
  128. [[ $print_warnings = 1 ]] &&
  129. echo "skipping $func address at $addr due to size mismatch ($size != $sym_size)"
  130. continue;
  131. fi
  132. # make sure the provided offset is within the symbol's range
  133. if [[ $offset -gt $sym_size ]]; then
  134. [[ $print_warnings = 1 ]] &&
  135. echo "skipping $func address at $addr due to size mismatch ($offset > $sym_size)"
  136. continue
  137. fi
  138. # separate multiple entries with a blank line
  139. [[ $FIRST = 0 ]] && echo
  140. FIRST=0
  141. # pass real address to addr2line
  142. echo "$func+$offset/$sym_size:"
  143. local file_lines=$(${ADDR2LINE} -fpie $objfile $addr | sed "s; $dir_prefix\(\./\)*; ;")
  144. [[ -z $file_lines ]] && return
  145. if [[ $LIST = 0 ]]; then
  146. echo "$file_lines" | while read -r line
  147. do
  148. echo $line
  149. done
  150. DONE=1;
  151. return
  152. fi
  153. # show each line with context
  154. echo "$file_lines" | while read -r line
  155. do
  156. echo
  157. echo $line
  158. n=$(echo $line | sed 's/.*:\([0-9]\+\).*/\1/g')
  159. n1=$[$n-5]
  160. n2=$[$n+5]
  161. f=$(echo $line | sed 's/.*at \(.\+\):.*/\1/g')
  162. awk 'NR>=strtonum("'$n1'") && NR<=strtonum("'$n2'") { if (NR=='$n') printf(">%d<", NR); else printf(" %d ", NR); printf("\t%s\n", $0)}' $f
  163. done
  164. DONE=1
  165. done < <(${NM} -n $objfile | awk -v fn=$func -v end=$file_end '$3 == fn { found=1; line=$0; start=$1; next } found == 1 { found=0; print line, "0x"$1 } END {if (found == 1) print line, end; }')
  166. }
  167. [[ $# -lt 2 ]] && usage
  168. objfile=$1
  169. LIST=0
  170. [[ "$objfile" == "--list" ]] && LIST=1 && shift && objfile=$1
  171. [[ ! -f $objfile ]] && die "can't find objfile $objfile"
  172. shift
  173. DIR_PREFIX=supercalifragilisticexpialidocious
  174. find_dir_prefix $objfile
  175. FIRST=1
  176. while [[ $# -gt 0 ]]; do
  177. func_addr=$1
  178. shift
  179. # print any matches found
  180. DONE=0
  181. __faddr2line $objfile $func_addr $DIR_PREFIX 0
  182. # if no match was found, print warnings
  183. if [[ $DONE = 0 ]]; then
  184. __faddr2line $objfile $func_addr $DIR_PREFIX 1
  185. warn "no match for $func_addr"
  186. fi
  187. done